<?php

namespace BitGoblin\MCST\Minecraft;

class Server {

  // server root directory
  private string $rootDir;
  // server name
  private string $serverName;
  // server Minecraft version
  private string $serverVersion;
  // PID file path
  private string $pidFilePath;
  // server run status
  private bool $state = false;

  // class constructor
  public function __construct($dir) {
    $dirBits = explode('/', $dir);
    $this->rootDir = $dir;
    $this->serverName = $dirBits[count($dirBits) - 1];
    $this->pidFilePath = $dir . '/pid.txt';

    // get server version
    $versionFile = join('/', array($this->rootDir, 'current_version.txt'));
    if (file_exists($versionFile)) {
      $this->serverVersion = file($versionFile)[0];
    }

    // search for server state
    if (file_exists($this->pidFilePath)) {
      $this->state = true;
    }
  }

  // start the server
  public function start(): void {
    // TODO - for now just set the state to true
    $this->state = true;
  }

  // stop the server
  public function stop(): void {
    // TODO - for now just set the state to false
    $this->state = false;
  }

  // getters & setters
  public function getDirectory(): string {
    return $this->rootDir;
  }
  public function getName(): string {
    return $this->serverName;
  }
  public function getVersion(): string {
    return $this->serverVersion;
  }
  public function getState(): bool {
    return $this->state;
  }

}
